diff -Naur tbnl-0.4.0/modlisp.lisp tbnl-0.4.0a/modlisp.lisp
--- tbnl-0.4.0/modlisp.lisp	Wed Mar 16 11:06:50 2005
+++ tbnl-0.4.0a/modlisp.lisp	Tue Mar 15 17:05:57 2005
@@ -324,11 +324,9 @@
                 (ignore-errors
                   (process-apache-command headers)
                   (force-output *apache-stream*))
-              (declare (ignorable result))
               (declare (ignorable code))
               (when code (format t "Error in TBNL:: CODE ~S -- RESULT ~S~%" code result))
-              (setf *close-apache-stream* t)
-              nil)))))
+              result)))))
 
 (defun get-apache-command ()
   "Reads alternating key/value lines and posted content \(if any) from
@@ -351,28 +349,27 @@
             headers))))))
 
 (defun apache-listen (*apache-stream* command-processor &rest args)
-  "Listens on *APACHE-STREAM* for commands from mod_lisp. Packages the
-command using GET-APACHE-COMMAND and passes it to the
-COMMAND-PROCESSOR function \(which is PROCESS-APACHE-COMMAND). ARGS
+  "Listens on *APACHE-STREAM* for commands from mod_lisp. Packages the                                                                   
+command using GET-APACHE-COMMAND and passes it to the                                                                                    
+COMMAND-PROCESSOR function \(which is PROCESS-APACHE-COMMAND). ARGS                                                                      
 are ignored. Designed to be called by a KMRCL:LISTENER object."
   (declare (ignore args))
   (let ((*close-apache-stream* t))
     (unwind-protect
-        (loop for *apache-socket-usage-counter* from 0
-              do (let ((command (debug-value *command* (get-apache-command))))
-                   (ignore-errors
-                     (when command
-                       (cond ((ignore-errors
-                                (funcall command-processor command))
-                              (ignore-errors
-                                (force-output *apache-stream*)))
-                             (t
-                              ;; if an error occured during processing of
-                              ;; COMMAND we close this particular connection
-                              ;; to Apache  
-                              (ignore-errors
-                                (setq *close-apache-stream* t)))))
-                     (when *close-apache-stream* (return)))))
+      (loop for *apache-socket-usage-counter* from 0
+            for command = (debug-value *command* (get-apache-command))
+            while command
+            do (cond ((ignore-errors
+                        (funcall command-processor command))
+                      (ignore-errors
+                        (force-output *apache-stream*)))
+                     (t
+                      ;; if an error occured during processing of                                                                        
+                      ;; COMMAND we close this particular connection                                                                     
+                      ;; to Apache                                                                                                       
+                      (ignore-errors
+                        (setq *close-apache-stream* t))))
+            until *close-apache-stream*)
       (ignore-errors
         (kmrcl:close-active-socket *apache-stream*)))))
 
